| helics 3.6.1

Public Member Functions | List of all members
helics::Core Class Referenceabstract

`#include <Core.hpp>`

Inheritance diagram for helics::Core:

## Public Member Functions
| Core ()=default
virtual | ~Core ()=default
virtual void | configure (std::string_view configureString)=0
virtual void | configureFromArgs (int argc, char *argv[])=0
virtual void | configureFromVector (std::vector< std::string > args)=0
virtual bool | isConfigured () const =0
virtual bool | connect ()=0
virtual bool | isConnected () const =0
virtual void | disconnect ()=0
virtual bool | hasError () const =0
virtual bool | waitForDisconnect (std::chrono::milliseconds msToWait=std::chrono::milliseconds(0)) const =0
virtual bool | isOpenToNewFederates () const =0
virtual const std::string & | getIdentifier () const =0
virtual const std::string & | getAddress () const =0
virtual void | globalError (LocalFederateId federateID, int32_t errorCode, std::string_view errorString)=0
virtual void | localError (LocalFederateId federateID, int32_t errorCode, std::string_view errorString)=0
virtual int | getErrorCode () const =0
virtual std::string | getErrorMessage () const =0
virtual void | finalize (LocalFederateId federateID)=0
virtual bool | enterInitializingMode (LocalFederateId federateID, IterationRequest iterate=NO_ITERATION)=0
virtual void | setCoreReadyToInit ()=0
virtual iteration_time | enterExecutingMode (LocalFederateId federateID, IterationRequest iterate=NO_ITERATION)=0
virtual LocalFederateId | registerFederate (std::string_view name, const CoreFederateInfo &info)=0
virtual const std::string & | getFederateName (LocalFederateId federateID) const =0
virtual LocalFederateId | getFederateId (std::string_view name) const =0
virtual int32_t | getFederationSize ()=0
virtual Time | timeRequest (LocalFederateId federateID, Time next)=0
virtual iteration_time | requestTimeIterative (LocalFederateId federateID, Time next, IterationRequest iterate)=0
virtual void | processCommunications (LocalFederateId fedId, std::chrono::milliseconds msToWait)=0
virtual void | setTimeProperty (LocalFederateId federateID, int32_t property, Time timeValue)=0
virtual Time | getTimeProperty (LocalFederateId federateID, int32_t property) const =0
virtual void | setIntegerProperty (LocalFederateId federateID, int32_t property, int16_t propValue)=0
virtual int16_t | getIntegerProperty (LocalFederateId federateID, int32_t property) const =0
virtual Time | getCurrentTime (LocalFederateId federateID) const =0
virtual void | setFlagOption (LocalFederateId federateID, int32_t flag, bool flagValue)=0
virtual bool | getFlagOption (LocalFederateId federateID, int32_t flag) const =0
virtual InterfaceHandle | registerPublication (LocalFederateId federateID, std::string_view key, std::string_view type, std::string_view units)=0
virtual InterfaceHandle | getPublication (LocalFederateId federateID, std::string_view key) const =0
virtual InterfaceHandle | registerInput (LocalFederateId federateID, std::string_view key, std::string_view type, std::string_view units)=0
virtual InterfaceHandle | getInput (LocalFederateId federateID, std::string_view key) const =0
virtual const std::string & | getHandleName (InterfaceHandle handle) const =0
virtual void | removeTarget (InterfaceHandle handle, std::string_view targetToRemove)=0
virtual const std::string & | getExtractionUnits (InterfaceHandle handle) const =0
virtual const std::string & | getInjectionUnits (InterfaceHandle handle) const =0
virtual const std::string & | getInjectionType (InterfaceHandle handle) const =0
virtual const std::string & | getExtractionType (InterfaceHandle handle) const =0
virtual void | setHandleOption (InterfaceHandle handle, int32_t option, int32_t option_value)=0
virtual int32_t | getHandleOption (InterfaceHandle handle, int32_t option) const =0
virtual void | closeHandle (InterfaceHandle handle)=0
virtual void | setValue (InterfaceHandle handle, const char *data, uint64_t len)=0
virtual const std::shared_ptr< const SmallBuffer > & | getValue (InterfaceHandle handle, uint32_t *inputIndex=nullptr)=0
virtual const std::vector< std::shared_ptr< const SmallBuffer > > & | getAllValues (InterfaceHandle handle)=0
virtual const std::vector< InterfaceHandle > & | getValueUpdates (LocalFederateId federateID)=0
virtual InterfaceHandle | registerEndpoint (LocalFederateId federateID, std::string_view name, std::string_view type)=0
virtual InterfaceHandle | registerTargetedEndpoint (LocalFederateId federateID, std::string_view name, std::string_view type)=0
virtual InterfaceHandle | getEndpoint (LocalFederateId federateID, std::string_view name) const =0
virtual InterfaceHandle | registerDataSink (LocalFederateId federateID, std::string_view name)=0
virtual InterfaceHandle | getDataSink (LocalFederateId federateID, std::string_view name) const =0
virtual InterfaceHandle | registerCloningFilter (std::string_view filterName, std::string_view type_in, std::string_view type_out)=0
virtual InterfaceHandle | registerFilter (std::string_view filterName, std::string_view type_in, std::string_view type_out)=0
virtual InterfaceHandle | registerTranslator (std::string_view translatorName, std::string_view endpointType, std::string_view units)=0
virtual void | addDestinationTarget (InterfaceHandle handle, std::string_view dest, InterfaceType hint=InterfaceType::UNKNOWN)=0
virtual void | addSourceTarget (InterfaceHandle handle, std::string_view name, InterfaceType hint=InterfaceType::UNKNOWN)=0
virtual const std::string & | getDestinationTargets (InterfaceHandle handle) const =0
virtual const std::string & | getSourceTargets (InterfaceHandle handle) const =0
virtual InterfaceHandle | getFilter (std::string_view name) const =0
virtual InterfaceHandle | getTranslator (std::string_view name) const =0
virtual void | addDependency (LocalFederateId federateID, std::string_view federateName)=0
virtual void | linkEndpoints (std::string_view source, std::string_view dest)=0
virtual void | addAlias (std::string_view interfaceKey, std::string_view alias)=0
virtual void | makeConnections (const std::string &file)=0
virtual void | dataLink (std::string_view source, std::string_view target)=0
virtual void | addSourceFilterToEndpoint (std::string_view filter, std::string_view target)=0
virtual void | addDestinationFilterToEndpoint (std::string_view filter, std::string_view target)=0
virtual void | send (InterfaceHandle sourceHandle, const void *data, uint64_t length)=0
virtual void | sendTo (InterfaceHandle sourceHandle, const void *data, uint64_t length, std::string_view destination)=0
virtual void | sendAt (InterfaceHandle sourceHandle, const void *data, uint64_t length, Time time)=0
virtual void | sendToAt (InterfaceHandle sourceHandle, const void *data, uint64_t length, std::string_view destination, Time time)=0
virtual void | sendMessage (InterfaceHandle sourceHandle, std::unique_ptr< Message > message)=0
virtual uint64_t | receiveCount (InterfaceHandle destination)=0
virtual std::unique_ptr< Message > | receive (InterfaceHandle destination)=0
virtual std::unique_ptr< Message > | receiveAny (LocalFederateId federateID, InterfaceHandle &endpoint_id)=0
virtual uint64_t | receiveCountAny (LocalFederateId federateID)=0
virtual void | logMessage (LocalFederateId federateID, int logLevel, std::string_view messageToLog)=0
virtual void | setFilterOperator (InterfaceHandle filter, std::shared_ptr< FilterOperator > callback)=0
virtual void | setTranslatorOperator (InterfaceHandle translator, std::shared_ptr< TranslatorOperator > callback)=0
virtual void | setFederateOperator (LocalFederateId fed, std::shared_ptr< FederateOperator > callback)=0
virtual void | setLoggingCallback (LocalFederateId federateID, std::function< void(int, std::string_view, std::string_view)> logFunction)=0
virtual void | setLoggingLevel (int logLevel)=0
virtual void | setLogFile (std::string_view lfile)=0
virtual void | setGlobal (std::string_view valueName, std::string_view value)=0
virtual void | sendCommand (std::string_view target, std::string_view commandStr, std::string_view source, HelicsSequencingModes mode)=0
virtual std::pair< std::string, std::string > | getCommand (LocalFederateId federateID)=0
virtual std::pair< std::string, std::string > | waitCommand (LocalFederateId federateID)=0
virtual std::string | query (std::string_view target, std::string_view queryStr, HelicsSequencingModes mode)=0
virtual void | setQueryCallback (LocalFederateId federateID, std::function< std::string(std::string_view)> queryFunction, int order)=0
virtual void | setInterfaceInfo (InterfaceHandle handle, std::string_view info)=0
virtual const std::string & | getInterfaceInfo (InterfaceHandle handle) const =0
virtual void | setInterfaceTag (InterfaceHandle handle, std::string_view tag, std::string_view value)=0
virtual const std::string & | getInterfaceTag (InterfaceHandle handle, std::string_view tag) const =0
virtual void | setFederateTag (LocalFederateId fid, std::string_view tag, std::string_view value)=0
virtual const std::string & | getFederateTag (LocalFederateId fid, std::string_view tag) const =0

## Detailed Description

the class defining the core interface through an abstract class

## Constructor & Destructor Documentation

## ◆ Core()

helics::Core::Core | ( |  | ) |
| default

default constructor

## ◆ ~Core()

virtual helics::Core::~Core | ( |  | ) |
| virtual default

virtual destructor

## Member Function Documentation

## ◆ addAlias()

virtual void helics::Core::addAlias | ( | std::string_view | interfaceKey,
|  | std::string_view | alias
| ) |  |
| pure virtual

add an interface alias This allows an interface to be referred to by multiple keys

Parameters

  interfaceKey | the name of the interface to generate an alias for
  alias | the additional identification string

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::addAlias().

## ◆ addDependency()

virtual void helics::Core::addDependency | ( | LocalFederateId | federateID,
|  | std::string_view | federateName
| ) |  |
| pure virtual

add a time dependency between federates

this function is primarily useful for Message federates which do not otherwise restrict the dependencies adding a dependency gives additional information to the core that the specified federate(given by id) will be sending Messages to the named Federate(by federateName)

Parameters

  federateID | the identifier for the federate
  federateName | the name of the dependent federate

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ addDestinationFilterToEndpoint()

virtual void helics::Core::addDestinationFilterToEndpoint | ( | std::string_view | filter,
|  | std::string_view | target
| ) |  |
| pure virtual

create a filter connection between a named filter and a named endpoint for destination processing

Parameters

  filter | the name of the filter
  target | the name of the source target

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ addDestinationTarget()

virtual void helics::Core::addDestinationTarget | ( | InterfaceHandle | handle,
|  | std::string_view | dest,
|  | InterfaceType | hint = `InterfaceType::UNKNOWN`
| ) |  |
| pure virtual

adds a destination for interface data, the handle can be a publication, endpoint, filter, or translators

a filter will create an additional processing step for messages before they get to a destination endpoint, for publications this will establish a linkage from the publication to the named input

Parameters

  handle | an interface to add the target to
  dest | the target endpoint for the filter
  hint | the interface type for the destination target

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::addDestinationTarget().

## ◆ addSourceFilterToEndpoint()

virtual void helics::Core::addSourceFilterToEndpoint | ( | std::string_view | filter,
|  | std::string_view | target
| ) |  |
| pure virtual

create a filter connection between a named filter and a named endpoint for messages coming from that endpoint

Parameters

  filter | the name of the filter
  target | the name of the source target

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ addSourceTarget()

virtual void helics::Core::addSourceTarget | ( | InterfaceHandle | handle,
|  | std::string_view | name,
|  | InterfaceType | hint = `InterfaceType::UNKNOWN`
| ) |  |
| pure virtual

adds a source of data to an interface, the handle can be an input, filter, translator, or endpoint

for subscriptions and inputs this establishes a link from a publication, for endpoints this creates a linkage to a particular publication, for filters it add a source endpoint to filter

Parameters

  handle | the identifier of the interface
  name | the name of the filter or its target
  hint | the interface type for the source target

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::addSourceTarget().

## ◆ closeHandle()

virtual void helics::Core::closeHandle | ( | InterfaceHandle | handle | ) |
| pure virtual

close a handle from further connections

Parameters

  handle | the handle from the publication, input, endpoint or filter

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::close(), and helics::ConnectorFederateManager::closeAllConnectors().

## ◆ configure()

virtual void helics::Core::configure | ( | std::string_view | configureString | ) |
| pure virtual

Configure the core from a configuration string

Should be invoked a single time to initialize the co-simulation core.

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ configureFromArgs()

virtual void helics::Core::configureFromArgs | ( | int | argc,
|  | char * | argv[]
| ) |  |
| pure virtual

Configure the core from command line arguments.

Should be invoked a single time to configure the co-simulation core for operation

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ configureFromVector()

virtual void helics::Core::configureFromVector | ( | std::vector< std::string > | args | ) |
| pure virtual

Configure the core from command line arguments contained in a vector in reverse order

Should be invoked a single time to configure the co-simulation core for operations

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ connect()

virtual bool helics::Core::connect | ( |  | ) |
| pure virtual

connect the core to a broker if needed

Returns
  true if the connection was successful

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ dataLink()

virtual void helics::Core::dataLink | ( | std::string_view | source,
|  | std::string_view | target
| ) |  |
| pure virtual

create a data connection between a named publication and a named input

Parameters

  source | the name of the publication
  target | the name of the input

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ disconnect()

virtual void helics::Core::disconnect | ( |  | ) |
| pure virtual

disconnect the core from its broker

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ enterExecutingMode()

virtual iteration_time helics::Core::enterExecutingMode | ( | LocalFederateId | federateID,
|  | IterationRequest | iterate = `NO_ITERATION`
| ) |  |
| pure virtual

Change the federate state to the Executing state.

May only be invoked in Initializing state.

Parameters

  federateID | the identifier of the federate
  iterate | the requested iteration mode if nonconverged the federate requests an iterative update

Returns
  an iteration_time result enumeration value indicating the current state of iterations and a time with the current simulation time (usually 0) unless the federate is joining dynamically

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ enterInitializingMode()

virtual bool helics::Core::enterInitializingMode | ( | LocalFederateId | federateID,
|  | IterationRequest | iterate = `NO_ITERATION`
| ) |  |
| pure virtual

Federates may be in five Modes.

1. Startup Configuration of the federate. State begins when registerFederate() is invoked and ends when enterInitializingMode() is invoked.
2. Initializing Configure of the simulation state prior to the start of time stepping. State begins when enterInitializingMode() is invoked and ends when enterExecutingMode(true) is invoked.
3. Executing State begins when enterExecutingMode() is invoked and ends when finalize() is invoked.
4. Finalized state after finalize is invoked.
5. Error state invoked after an error is called. Change the federate state to the Initializing state.

Parameters

  federateID | the identifier of the federate
  iterate | the requested iteration mode, ITERATE_IF_NEEDED will operate identically to FORCE_ITERATION in this case

May only be invoked in Created state otherwise an error is thrown for callback federates this call passes full control to the core

Returns
  will return true if the call resulted in Initializing mode being reached

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ finalize()

virtual void helics::Core::finalize | ( | LocalFederateId | federateID | ) |
| pure virtual

Federate has completed.

Should be invoked a single time to complete the simulation.

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getAddress()

virtual const std::string& helics::Core::getAddress | ( |  | ) | const
| pure virtual

get the connection network or connection address for the core

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getAllValues()

virtual const std::vector<std::shared_ptr<const SmallBuffer> >& helics::Core::getAllValues | ( | InterfaceHandle | handle | ) |
| pure virtual

Return all the available data for the specified handle or the latest input

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getCommand()

virtual std::pair<std::string, std::string> helics::Core::getCommand | ( | LocalFederateId | federateID | ) |
| pure virtual

get a command for a specific federate

Implemented in helics::EmptyCore, and helics::CommonCore.

## ◆ getCurrentTime()

virtual Time helics::Core::getCurrentTime | ( | LocalFederateId | federateID | ) | const
| pure virtual

get the most recent granted Time

Parameters

  federateID | the identifier of the federate to get the time

Returns
  the most recent granted time or the startup time

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getDataSink()

virtual InterfaceHandle helics::Core::getDataSink | ( | LocalFederateId | federateID,
|  | std::string_view | name
| ) |  | const
| pure virtual

get an interface handle to a data sink

Parameters

  federateID | the identifier for the federate
  name | the name of the data sink

Returns
  a handle to identify the sink

Implemented in helics::EmptyCore, and helics::CommonCore.

## ◆ getDestinationTargets()

virtual const std::string& helics::Core::getDestinationTargets | ( | InterfaceHandle | handle | ) | const
| pure virtual

get the destinations for an interface

Parameters

  handle | an interface get the destination targets for

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::getDestinationTargets().

## ◆ getEndpoint()

virtual InterfaceHandle helics::Core::getEndpoint | ( | LocalFederateId | federateID,
|  | std::string_view | name
| ) |  | const
| pure virtual

get an endpoint Handle from its name

Parameters

  federateID | the identifier for the federate
  name | the name of the endpoint

Returns
  a handle to identify the endpoint

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getErrorCode()

virtual int helics::Core::getErrorCode | ( |  | ) | const
| pure virtual

get the last error code from a core

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getErrorMessage()

virtual std::string helics::Core::getErrorMessage | ( |  | ) | const
| pure virtual

get the last error message

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getExtractionType()

virtual const std::string& helics::Core::getExtractionType | ( | InterfaceHandle | handle | ) | const
| pure virtual

get the type for which data comes out of an interface, this is the type for data coming into an interface

for filters this is the output type, for publications this is the specified type, for endpoints this is the specified type and for inputs this is the specified type

Parameters

  handle | the interface handle to get the injection type for

Returns
  a const ref to std::string

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::getExtractionType().

## ◆ getExtractionUnits()

virtual const std::string& helics::Core::getExtractionUnits | ( | InterfaceHandle | handle | ) | const
| pure virtual

Returns
  the unit string for the specified handle.

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::getExtractionUnits().

## ◆ getFederateId()

virtual LocalFederateId helics::Core::getFederateId | ( | std::string_view | name | ) | const
| pure virtual

Returns the federate Id.

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getFederateName()

virtual const std::string& helics::Core::getFederateName | ( | LocalFederateId | federateID | ) | const
| pure virtual

Returns the federate name.

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getFederateTag()

virtual const std::string& helics::Core::getFederateTag | ( | LocalFederateId | fid,
|  | std::string_view | tag
| ) |  | const
| pure virtual

getter for the federate tags

Parameters

  fid | the identifier for the federate to get the tag data for
  tag | the name of the tag to retrieve

Returns
  a reference to a const std::string with the tag value.

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getFederationSize()

virtual int32_t helics::Core::getFederationSize | ( |  | ) |
| pure virtual

Returns the global number of federates that are registered only return accurately after the initialization state has been entered

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getFilter()

virtual InterfaceHandle helics::Core::getFilter | ( | std::string_view | name | ) | const
| pure virtual

get a filter Handle from its name or target(this may not be unique so it will only find the first one)

Parameters

  name | the name of the filter or its target

Returns
  a handle to identify the filter

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getFlagOption()

virtual bool helics::Core::getFlagOption | ( | LocalFederateId | federateID,
|  | int32_t | flag
| ) |  | const
| pure virtual

Set a flag in a a federate

Parameters

  federateID | the identifier for the federate
  flag | an index code for the flag to set

Returns
  the value of the flag

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getHandleName()

virtual const std::string& helics::Core::getHandleName | ( | InterfaceHandle | handle | ) | const
| pure virtual

Returns the name or identifier for a specified handle

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::getName(), helics::ConnectorFederateManager::registerCloningFilter(), helics::ConnectorFederateManager::registerFilter(), and helics::ConnectorFederateManager::registerTranslator().

## ◆ getHandleOption()

virtual int32_t helics::Core::getHandleOption | ( | InterfaceHandle | handle,
|  | int32_t | option
| ) |  | const
| pure virtual

get a handle option

Parameters

  handle | the handle from the publication, input, endpoint or filter
  option | the option to set see /ref defs::options

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::getOption().

## ◆ getIdentifier()

virtual const std::string& helics::Core::getIdentifier | ( |  | ) | const
| pure virtual

get an identifier string for the core

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getInjectionType()

virtual const std::string& helics::Core::getInjectionType | ( | InterfaceHandle | handle | ) | const
| pure virtual

get the injection type for an interface, this is the type for data coming into an interface

for filters this is the input type, for publications this is type used to transmit data, for endpoints this is the specified type and for inputs this is the type of the transmitting publication

Parameters

  handle | the interface handle to get the injection type for

Returns
  a const ref to std::string

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::getInjectionType().

## ◆ getInjectionUnits()

virtual const std::string& helics::Core::getInjectionUnits | ( | InterfaceHandle | handle | ) | const
| pure virtual

get the injection units for an interface, this is the type for data coming into an interface

for publications this is the units associated with the transmitted data, for inputs this is the units of the transmitting publication

Parameters

  handle | the interface handle to get the injection type for

Returns
  a const ref to std::string

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::getInjectionUnits().

## ◆ getInput()

virtual InterfaceHandle helics::Core::getInput | ( | LocalFederateId | federateID,
|  | std::string_view | key
| ) |  | const
| pure virtual

get a subscription Handle from its key

Parameters

  federateID | the identifier for the federate
  key | the tag of the named input

Returns
  a handle to identify the input

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getIntegerProperty()

virtual int16_t helics::Core::getIntegerProperty | ( | LocalFederateId | federateID,
|  | int32_t | property
| ) |  | const
| pure virtual

get an integer property on a federate

Parameters

  federateID | the federate to set a time based property on
  property | the property to set see /ref defs::properties

Returns
  the current value of the property

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getInterfaceInfo()

virtual const std::string& helics::Core::getInterfaceInfo | ( | InterfaceHandle | handle | ) | const
| pure virtual

getter for the interface information

Parameters

  handle | the identifiers for the interface to query

Returns
  a string containing the Info data stored in an interface

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::getInfo().

## ◆ getInterfaceTag()

virtual const std::string& helics::Core::getInterfaceTag | ( | InterfaceHandle | handle,
|  | std::string_view | tag
| ) |  | const
| pure virtual

getter for the interface tags

Parameters

  handle | the identifier for the interface to set the info data on
  tag | the name of the tag to retrieve

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::getTag().

## ◆ getPublication()

virtual InterfaceHandle helics::Core::getPublication | ( | LocalFederateId | federateID,
|  | std::string_view | key
| ) |  | const
| pure virtual

get a publication Handle from its key

Parameters

  federateID | the identifier for the federate
  key | the name of the publication

Returns
  a handle to identify the publication

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getSourceTargets()

virtual const std::string& helics::Core::getSourceTargets | ( | InterfaceHandle | handle | ) | const
| pure virtual

get the sources of data for an interface

Parameters

  handle | the identifier of the interface

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::getSourceTargets(), and helics::Interface::getTarget().

## ◆ getTimeProperty()

virtual Time helics::Core::getTimeProperty | ( | LocalFederateId | federateID,
|  | int32_t | property
| ) |  | const
| pure virtual

get a timebased property on a federate

Parameters

  federateID | the federate to set a time based property on
  property | the property to set see /ref defs::properties

Returns
  the current value of the requested property

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getTranslator()

virtual InterfaceHandle helics::Core::getTranslator | ( | std::string_view | name | ) | const
| pure virtual

get a translator handle from its name or target (this may not be unique so it will only find the first one)

Parameters

  name | the name of the translator or its target

Returns
  a handle to identify the translator

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getValue()

virtual const std::shared_ptr<const SmallBuffer>& helics::Core::getValue | ( | InterfaceHandle | handle,
|  | uint32_t * | inputIndex = `nullptr`
| ) |  |
| pure virtual

Return the data for the specified handle or the latest input

Parameters

  | handle | the input handle from which to get the data
  [out] | inputIndex | return the index of input (always 1 for inputs with only a single source)

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ getValueUpdates()

virtual const std::vector<InterfaceHandle>& helics::Core::getValueUpdates | ( | LocalFederateId | federateID | ) |
| pure virtual

Returns vector of input handles that received an update during the last time request. The data remains valid until the next call to getValueUpdates for the given federateID

Parameters

  federateID | the identification code of the federate to get which interfaces have been updated

Returns
  a reference to the location of an array of handles that have been updated

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ globalError()

virtual void helics::Core::globalError | ( | LocalFederateId | federateID,
|  | int32_t | errorCode,
|  | std::string_view | errorString
| ) |  |
| pure virtual

Federate has encountered a global error and the federation should halt.

Parameters

  federateID | the federate
  errorCode | a numerical code associated with the error
  errorString | a text message associated with the error

## ◆ isConfigured()

virtual bool helics::Core::isConfigured | ( |  | ) | const
| pure virtual

Returns true if the core has been configured.

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ isConnected()

virtual bool helics::Core::isConnected | ( |  | ) | const
| pure virtual

check if the core is connected properly

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ isOpenToNewFederates()

virtual bool helics::Core::isOpenToNewFederates | ( |  | ) | const
| pure virtual

check if the core is ready to accept new federates

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ linkEndpoints()

virtual void helics::Core::linkEndpoints | ( | std::string_view | source,
|  | std::string_view | dest
| ) |  |
| pure virtual

Register communicating source/destination endpoint targets.

Parameters

  source | the endpoint that is sending data
  dest | the endpoint receiving the data

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ localError()

virtual void helics::Core::localError | ( | LocalFederateId | federateID,
|  | int32_t | errorCode,
|  | std::string_view | errorString
| ) |  |
| pure virtual

Federate has encountered a local error and should be disconnected.

Parameters

  federateID | the federate
  errorCode | a numerical code associated with the error
  errorString | a text message associated with the error

## ◆ logMessage()

virtual void helics::Core::logMessage | ( | LocalFederateId | federateID,
|  | int | logLevel,
|  | std::string_view | messageToLog
| ) |  |
| pure virtual

send a log message to the Core for logging

Parameters

  federateID | the federate that is sending the log message
  logLevel | an integer for the log level /ref helics_log_levels
  messageToLog | the string to send to a logger

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ makeConnections()

virtual void helics::Core::makeConnections | ( | const std::string & | file | ) |
| pure virtual

load a file containing connection information

Parameters

  file | a JSON or TOML file containing connection information

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ processCommunications()

virtual void helics::Core::processCommunications | ( | LocalFederateId | fedId,
|  | std::chrono::milliseconds | msToWait
| ) |  |
| pure virtual

blocking call that processes helics communication messages this call can be used when expecting communication from other federates or when the federate has nothing else to do and doesn't want to advance time

Parameters

  fedId | the ID of the federate to process communications for
  msToWait | the amount of time to wait before the function returns from processing communications

Implemented in helics::EmptyCore, and helics::CommonCore.

## ◆ query()

virtual std::string helics::Core::query | ( | std::string_view | target,
|  | std::string_view | queryStr,
|  | HelicsSequencingModes | mode
| ) |  |
| pure virtual

make a query for information from the co-simulation

the format is somewhat unspecified target is the name of an object typically one of "federation", "broker", "core", or the name of a specific object/core/broker target can also be "global_value" to query a global value stored in the broker, or "global" to get a json structure with the name and value

Parameters

  target | the specific target of the query
  queryStr | the actual query
  mode | the sequencing mode for the query, fast or ordered

Returns
  a string containing the response to the query. Query is a blocking call and will not return until the query is answered so use with caution

Implemented in helics::EmptyCore, and helics::CommonCore.

## ◆ receive()

virtual std::unique_ptr<Message> helics::Core::receive | ( | InterfaceHandle | destination | ) |
| pure virtual

Returns the next buffered message the specified destination endpoint.

this is a non-blocking call and will return a nullptr if no message are available

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ receiveAny()

virtual std::unique_ptr<Message> helics::Core::receiveAny | ( | LocalFederateId | federateID,
|  | InterfaceHandle & | endpoint_id
| ) |  |
| pure virtual

Receives a message for any destination.

this is a non-blocking call and will return a nullptr if no messages are available

Parameters

  | federateID | the identifier for the federate
  [out] | endpoint_id | the endpoint handle related to the message gets stored here

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::MessageFederateManager::updateTime().

## ◆ receiveCount()

virtual uint64_t helics::Core::receiveCount | ( | InterfaceHandle | destination | ) |
| pure virtual

Returns the number of pending receives for the specified destination endpoint.

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ receiveCountAny()

virtual uint64_t helics::Core::receiveCountAny | ( | LocalFederateId | federateID | ) |
| pure virtual

Returns number of messages for all destinations.

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::MessageFederateManager::updateTime().

## ◆ registerCloningFilter()

virtual InterfaceHandle helics::Core::registerCloningFilter | ( | std::string_view | filterName,
|  | std::string_view | type_in,
|  | std::string_view | type_out
| ) |  |
| pure virtual

Register a cloning filter, a cloning filter operates on a copy of the message vs the actual message

Parameters

  filterName | the name of the filter (may be left blank and one will be automatically assigned)
  type_in | the input type of the filter
  type_out | the output type of the filter (may be left blank if the filter doesn't change type)

Returns
  the handle for the new filter

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::CloningFilter::CloningFilter(), and helics::ConnectorFederateManager::registerCloningFilter().

## ◆ registerDataSink()

virtual InterfaceHandle helics::Core::registerDataSink | ( | LocalFederateId | federateID,
|  | std::string_view | name
| ) |  |
| pure virtual

Register a data sink which can only receive data from specific targets

Parameters

  federateID | the federate to associate the endpoint with
  name | the name of the sink

Returns
  a handle to identify the sink

Implemented in helics::EmptyCore, and helics::CommonCore.

Referenced by helics::MessageFederateManager::registerDataSink().

## ◆ registerEndpoint()

virtual InterfaceHandle helics::Core::registerEndpoint | ( | LocalFederateId | federateID,
|  | std::string_view | name,
|  | std::string_view | type
| ) |  |
| pure virtual

Message interface. Designed for point-to-point communication patterns. Register an endpoint.

Parameters

  federateID | the federate to associate the endpoint with
  name | the name of the endpoint
  type | the type of data the endpoint should accept or generate(can be left empty)

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::MessageFederateManager::registerEndpoint().

## ◆ registerFederate()

virtual LocalFederateId helics::Core::registerFederate | ( | std::string_view | name,
|  | const CoreFederateInfo & | info
| ) |  |
| pure virtual

Register a federate.

The returned FederateId is local to invoking process, FederateId's should not be used as a global identifier.

May only be invoked in initialize state otherwise throws an error

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ registerFilter()

virtual InterfaceHandle helics::Core::registerFilter | ( | std::string_view | filterName,
|  | std::string_view | type_in,
|  | std::string_view | type_out
| ) |  |
| pure virtual

Register filter.

May only be invoked in the Initialization state.

Parameters

  filterName | the name of the filter (may be left blank and one will be automatically assigned)
  type_in | the input type of the filter
  type_out | the output type of the filter (may be left blank if the filter doesn't change type) this is important for ordering in filters with operators

Returns
  the handle for the new filter

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Filter::Filter(), and helics::ConnectorFederateManager::registerFilter().

## ◆ registerInput()

virtual InterfaceHandle helics::Core::registerInput | ( | LocalFederateId | federateID,
|  | std::string_view | key,
|  | std::string_view | type,
|  | std::string_view | units
| ) |  |
| pure virtual

Register a control input for the specified federate.

May only be invoked in the initialize state.

Parameters

  federateID | the identifier for the federate to register an input interface on
  key | the name of the control input
  type | a string describing the type of the federate
  units | a string naming the units of the federate

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ registerPublication()

virtual InterfaceHandle helics::Core::registerPublication | ( | LocalFederateId | federateID,
|  | std::string_view | key,
|  | std::string_view | type,
|  | std::string_view | units
| ) |  |
| pure virtual

Value interface. Register a publication.

May only be invoked in the initialize state.

Parameters

  federateID | the identifier for the federate
  key | the tag for the publication
  type | the type of data the publication produces
  units | the units associated with the publication

Returns
  a handle to identify the publication

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ registerTargetedEndpoint()

virtual InterfaceHandle helics::Core::registerTargetedEndpoint | ( | LocalFederateId | federateID,
|  | std::string_view | name,
|  | std::string_view | type
| ) |  |
| pure virtual

Register an endpoint which can only send or receive to specific targets

Parameters

  federateID | the federate to associate the endpoint with
  name | the name of the endpoint
  type | the type of data the endpoint should accept or generate(can be left empty)

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::MessageFederateManager::registerTargetedEndpoint().

## ◆ registerTranslator()

virtual InterfaceHandle helics::Core::registerTranslator | ( | std::string_view | translatorName,
|  | std::string_view | endpointType,
|  | std::string_view | units
| ) |  |
| pure virtual

Register translator.

Parameters

  translatorName | the name of the translator (may be left blank and one will be automatically assigned)
  units | the specified units for the value side of the translator
  endpointType | a user specified name of the type data on the endpoint

Returns
  the handle for the new translator

Implemented in helics::EmptyCore, and helics::CommonCore.

Referenced by helics::ConnectorFederateManager::registerTranslator(), and helics::Translator::Translator().

## ◆ removeTarget()

virtual void helics::Core::removeTarget | ( | InterfaceHandle | handle,
|  | std::string_view | targetToRemove
| ) |  |
| pure virtual

remove a target from a handles operation

Parameters

  handle | the handle from the publication, input, endpoint or filter
  targetToRemove | the name of the target to remove

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::removeTarget().

## ◆ requestTimeIterative()

virtual iteration_time helics::Core::requestTimeIterative | ( | LocalFederateId | federateID,
|  | Time | next,
|  | IterationRequest | iterate
| ) |  |
| pure virtual

Request a new time advancement window for reiterative federates.

Reiterative federates block on requestTimeIterative() until all reiterative federates have invoked requestTimeIterative(). The bool returned a global AND of all localConverged values. If globalConverged is false, time returned is the previous granted time. Time should not advance and another iteration attempted. Federates should recompute state based on newly published values. Time is advanced only when all reiterative federates have converged. If globalConverged is True, grantedTime is the minimum of over all next times in both reiterative and non-reiterative federates.

If a federate determines it cannot converge it should invoke the error() method.

Federates only participate it in reiterations for times that are evenly divisible by the federates time delta.

May only be invoked in Executing state.

Non-reiterative federates may not invoke this method.

Parameters

  federateID | the identifier for the federate to process
  next | the requested time
  iterate | the requested iteration mode /ref iteration_request

Returns
  an /ref iteration_time object with two field grantedTime and a enumeration indicating the state of the iteration

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ send()

virtual void helics::Core::send | ( | InterfaceHandle | sourceHandle,
|  | const void * | data,
|  | uint64_t | length
| ) |  |
| pure virtual

Send data from a source to its targets

Time is implicitly defined as the end of the current time advancement window (value returned by last call to nextTime().

This send version was designed to enable communication of data between federates with the possible introduction of source and destination filters to represent properties of a communication network. This enables simulations to be run with/without a communications model present.

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ sendAt()

virtual void helics::Core::sendAt | ( | InterfaceHandle | sourceHandle,
|  | const void * | data,
|  | uint64_t | length,
|  | Time | time
| ) |  |
| pure virtual

Send data from source to destination with explicit expected delivery time.

Time supplied is the time that will be reported in the message in the receiving federate.

This send version was designed to enable communication of events between discrete event federates. For this use case the receiving federate can deserialize the data and schedule an event for the specified time.

Parameters

  sourceHandle | the source of the event
  data | the raw data for the event
  length | the record length of the event
  time | the time the event is scheduled for

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ sendCommand()

virtual void helics::Core::sendCommand | ( | std::string_view | target,
|  | std::string_view | commandStr,
|  | std::string_view | source,
|  | HelicsSequencingModes | mode
| ) |  |
| pure virtual

send a command to a specific target

the format is somewhat unspecified; target is the name of an object, typically one of "federation", "broker", "core", or the name of a specific object/core/broker

Parameters

  target | the specific target of the command
  commandStr | the actual command
  source | the designated source of the command, for return values or indication
  mode | the sequencing mode for the command, fast or ordered

Implemented in helics::EmptyCore, and helics::CommonCore.

## ◆ sendMessage()

virtual void helics::Core::sendMessage | ( | InterfaceHandle | sourceHandle,
|  | std::unique_ptr< Message > | message
| ) |  |
| pure virtual

Send for filters.

Continues sending the message to the next filter or to final destination.

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ sendTo()

virtual void helics::Core::sendTo | ( | InterfaceHandle | sourceHandle,
|  | const void * | data,
|  | uint64_t | length,
|  | std::string_view | destination
| ) |  |
| pure virtual

Send data from source to destination.

Time is implicitly defined as the end of the current time advancement window (value returned by last call to nextTime().

This send version was designed to enable communication of data between federates with the possible introduction of source and destination filters to represent properties of a communication network. This enables simulations to be run with/without a communications model present.

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ sendToAt()

virtual void helics::Core::sendToAt | ( | InterfaceHandle | sourceHandle,
|  | const void * | data,
|  | uint64_t | length,
|  | std::string_view | destination,
|  | Time | time
| ) |  |
| pure virtual

Send data from source to destination with explicit expected delivery time.

Time supplied is the time that will be reported in the message in the receiving federate.

This send version was designed to enable communication of events between discrete event federates. For this use case the receiving federate can deserialize the data and schedule an event for the specified time.

Parameters

  sourceHandle | the source of the event
  data | the raw data for the event
  length | the record length of the event
  destination | the target of the event
  time | the time the event is scheduled for

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ setCoreReadyToInit()

virtual void helics::Core::setCoreReadyToInit | ( |  | ) |
| pure virtual

set the core to ready to enter init

this function only needs to be called for cores that don't have any federates but may have filters for cores with federates it won't do anything

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ setFederateOperator()

virtual void helics::Core::setFederateOperator | ( | LocalFederateId | fed,
|  | std::shared_ptr< FederateOperator > | callback
| ) |  |
| pure virtual

set the callback Federate operators

Parameters

  fed | the federate to set the callback for
  callback | pointer to the operator class executing the federate

Implemented in helics::EmptyCore, and helics::CommonCore.

## ◆ setFederateTag()

virtual void helics::Core::setFederateTag | ( | LocalFederateId | fid,
|  | std::string_view | tag,
|  | std::string_view | value
| ) |  |
| pure virtual

setter for federate tags which are key-value pairs

Parameters

  fid | the identifier for the federate to set the tag data on
  tag | a string containing the name of the tag
  value | a string containing the value for the tag

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ setFilterOperator()

virtual void helics::Core::setFilterOperator | ( | InterfaceHandle | filter,
|  | std::shared_ptr< FilterOperator > | callback
| ) |  |
| pure virtual

set the filter callback operator

Parameters

  filter | the handle of the filter
  callback | pointer to the operator class executing the filter

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Filter::setFilterOperations(), and helics::Filter::setOperator().

## ◆ setFlagOption()

virtual void helics::Core::setFlagOption | ( | LocalFederateId | federateID,
|  | int32_t | flag,
|  | bool | flagValue
| ) |  |
| pure virtual

Set a flag in a a federate

Parameters

  federateID | the identifier for the federate
  flag | an index code for the flag to set
  flagValue | the value to set the flag to

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ setGlobal()

virtual void helics::Core::setGlobal | ( | std::string_view | valueName,
|  | std::string_view | value
| ) |  |
| pure virtual

set a federation global value

this overwrites any previous value for this name

Parameters

  valueName | the name of the global to set
  value | the value of the global

Implemented in helics::EmptyCore, and helics::CommonCore.

## ◆ setHandleOption()

virtual void helics::Core::setHandleOption | ( | InterfaceHandle | handle,
|  | int32_t | option,
|  | int32_t | option_value
| ) |  |
| pure virtual

set a handle option

Parameters

  handle | the handle from the publication, input, endpoint or filter
  option | the option to set
  option_value | the value to set the option (mostly 0 or 1)

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::setOption().

## ◆ setIntegerProperty()

virtual void helics::Core::setIntegerProperty | ( | LocalFederateId | federateID,
|  | int32_t | property,
|  | int16_t | propValue
| ) |  |
| pure virtual

set an integer property on a federate

Parameters

  federateID | the federate to set a time based property on
  property | the property to set see /ref defs::properties
  propValue | the requested value of the property

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ setInterfaceInfo()

virtual void helics::Core::setInterfaceInfo | ( | InterfaceHandle | handle,
|  | std::string_view | info
| ) |  |
| pure virtual

setter for the interface information

Parameters

  handle | the identifiers for the interface to set the info data on
  info | a string containing the info data

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::setInfo().

## ◆ setInterfaceTag()

virtual void helics::Core::setInterfaceTag | ( | InterfaceHandle | handle,
|  | std::string_view | tag,
|  | std::string_view | value
| ) |  |
| pure virtual

setter for interface tags which are key-value pairs

Parameters

  handle | the identifier for the interface to set the tag data on
  tag | a string containing the name of the tag
  value | a string containing the value for the tag

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Interface::setTag().

## ◆ setLogFile()

virtual void helics::Core::setLogFile | ( | std::string_view | lfile | ) |
| pure virtual

set the core logging file

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ setLoggingCallback()

virtual void helics::Core::setLoggingCallback | ( | LocalFederateId | federateID,
|  | std::function< void(int, std::string_view, std::string_view)> | logFunction
| ) |  |
| pure virtual

define a logging function to use for logging message and notices from the federation and individual federate

Parameters

  federateID | the identifier for the individual federate or 0 for the Core Logger
  logFunction | the callback function for doing something with a log message it takes 3 inputs an integer for logLevel /ref helics_log_levels A string indicating the source of the message and another string with the actual message

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ setLoggingLevel()

virtual void helics::Core::setLoggingLevel | ( | int | logLevel | ) |
| pure virtual

set the core logging level

Implemented in helics::EmptyCore, and helics::CommonCore.

## ◆ setQueryCallback()

virtual void helics::Core::setQueryCallback | ( | LocalFederateId | federateID,
|  | std::function< std::string(std::string_view)> | queryFunction,
|  | int | order
| ) |  |
| pure virtual

supply a query callback function

the intention of the query callback is to allow federates to answer particular requests through the query interface this allows other federates to make requests or queries of other federates in an asynchronous fashion.

Parameters

  federateID | the identifier for the federate
  queryFunction | a function object that returns a string as a result of a query in the form of const string ref. This callback will be called when a federate received a query that cannot be answered that directed at a particular federate
  order | indicator of the execution order slot for query callbacks; the value is bound [1,10] inclusive and values given outside this range are clamped to the boundary values. The callback is overwritten if multiple callbacks at the same index are given.

Implemented in helics::EmptyCore, and helics::CommonCore.

## ◆ setTimeProperty()

virtual void helics::Core::setTimeProperty | ( | LocalFederateId | federateID,
|  | int32_t | property,
|  | Time | timeValue
| ) |  |
| pure virtual

set a timebased property on a federate

Parameters

  federateID | the federate to set a time based property on
  property | the property to set see /ref defs::properties
  timeValue | the requested value of the property

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ setTranslatorOperator()

virtual void helics::Core::setTranslatorOperator | ( | InterfaceHandle | translator,
|  | std::shared_ptr< TranslatorOperator > | callback
| ) |  |
| pure virtual

set the translator callback operators

Parameters

  translator | the handle of the translator
  callback | pointer to the operator class executing the translator

Implemented in helics::CommonCore, and helics::EmptyCore.

Referenced by helics::Translator::setTranslatorOperations().

## ◆ setValue()

virtual void helics::Core::setValue | ( | InterfaceHandle | handle,
|  | const char * | data,
|  | uint64_t | len
| ) |  |
| pure virtual

Publish specified data to the specified key.

Parameters

  handle | the handle from the publication, input, endpoint or filter
  data | the raw data to send
  len | the size of the data

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ timeRequest()

virtual Time helics::Core::timeRequest | ( | LocalFederateId | federateID,
|  | Time | next
| ) |  |
| pure virtual

Time management. Request a new time advancement window for non-reiterative federates.

RequestTime() blocks until all non-reiterative federates have invoked requestTime() and all reiterative federates have converged (called requestTimeIterative() with localConverged value of true). Return time is the minimum of all supplied times.

May only be invoked in Executing state.

Iterative federates may not invoke this method.

Parameters

  federateID | the identification of the federate requesting the time
  next | the next time that is requested from the federate

Implemented in helics::CommonCore, and helics::EmptyCore.

## ◆ waitCommand()

virtual std::pair<std::string, std::string> helics::Core::waitCommand | ( | LocalFederateId | federateID | ) |
| pure virtual

get a command for a specific federate. block until a command is received

Implemented in helics::EmptyCore, and helics::CommonCore.

## ◆ waitForDisconnect()

virtual bool helics::Core::waitForDisconnect | ( | std::chrono::milliseconds | msToWait = `std::chrono::milliseconds(0)` | ) | const
| pure virtual

waits in the current thread until the core is disconnected

Returns
  true if the disconnect was successful

Implemented in helics::CommonCore, and helics::EmptyCore.

The documentation for this class was generated from the following file:

- core/Core.hpp